<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>Pokemon Card Game</title>
    <style>
        html,
        body {
            width: 100%;
            height: 100%;
        }

        * {
            margin: 0;
            padding: 0;
        }
    </style>
</head>
<body>
<canvas id="canvas"></canvas>
</body>

<script>
    /* */
    // const TO_RADIANS = Math.PI / 180;

    /* utils */
    function getRandomInt(min, max) {
        return Math.floor(Math.random() * (max - min)) + min;
    }

    function getRandomCards() {
        let cards = [];
        for (let i = 0; i < 60; i++) {
            cards.push(`cards/low/swsh8-${getRandomInt(1, 285)}.png`);
            // cards.push(`cards/low/swsh8-${getRandomInt(1, 285)}-pngquant.png`);
        }
        return cards
    }

    /* status */
    let game_status = {
        "player_1": {
            "deck": getRandomCards(),
            "active": null,
            "bench": [],
            "discard": [],
            "prizes": []
        },
        "player_2": {
            "deck": getRandomCards(),
            "active": null,
            "bench": [],
            "discard": [],
            "prizes": []
        }
    }

    /* */
    class Card {
        constructor(src, x, y, w, h, card) {
            this.src = src;
            this.x = x;
            this.y = y;
            this.w = w;
            this.h = h;
            this.card = card;
        }
    }

    /* fullscreen */
    (function () {
        const canvas = document.getElementById('canvas');
        const ctx = canvas.getContext('2d');
        const cards_margin = 16
        const card_w = 150;
        const card_h = 210;

        // resize the canvas to fill browser window dynamically
        window.addEventListener('resize', resizeCanvas, false);

        function resizeCanvas() {
            canvas.width = document.documentElement.clientWidth;
            canvas.height = document.documentElement.clientHeight;
            drawCanvas();
        }

        resizeCanvas();

        function drawCanvas() {
            /* playmat */

            // middle line
            ctx.beginPath();
            ctx.moveTo(0, canvas.height / 2);
            ctx.lineTo(canvas.width, canvas.height / 2);
            ctx.stroke();

            /*  */
            ctx.lineWidth = 4;
            ctx.fillStyle = '#ddd';
            ctx.strokeStyle = '#333';

            // Player 1
            ctx.fillRect(.5 * canvas.width - card_w / 2, .5 * canvas.height - cards_margin - card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - 5 * card_w / 2 - 2 * cards_margin, .5 * canvas.height - 2 * cards_margin - 2 * card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - 3 * card_w / 2 - cards_margin, .5 * canvas.height - 2 * cards_margin - 2 * card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - card_w / 2, .5 * canvas.height - 2 * cards_margin - 2 * card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width + card_w / 2 + cards_margin, .5 * canvas.height - 2 * cards_margin - 2 * card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width + 3 * card_w / 2 + 2 * cards_margin, .5 * canvas.height - 2 * cards_margin - 2 * card_h, card_w, card_h);
            // Player 2
            ctx.fillRect(.5 * canvas.width - card_w / 2, .5 * canvas.height + cards_margin, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - 5 * card_w / 2 - 2 * cards_margin, .5 * canvas.height + 2 * cards_margin + card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - 3 * card_w / 2 - cards_margin, .5 * canvas.height + 2 * cards_margin + card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width - card_w / 2, .5 * canvas.height + 2 * cards_margin + card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width + card_w / 2 + cards_margin, .5 * canvas.height + 2 * cards_margin + card_h, card_w, card_h);
            ctx.fillRect(.5 * canvas.width + 3 * card_w / 2 + 2 * cards_margin, .5 * canvas.height + 2 * cards_margin + card_h, card_w, card_h);
        }

        function update_deck_1(deck) {
            if (deck.length === 0) {
                return;
            }
            let back_img = new Image();
            back_img.src = "assets/cardback.png";
            back_img.onload = function () {
                ctx.drawImage(back_img,
                    .5 * canvas.width - 5 * card_w / 2 - 2 * cards_margin + 2,
                    .5 * canvas.height - card_h - cards_margin + 2,
                    card_w - 4,
                    card_h - 4
                );
            }
        }

        function update_deck_2(deck) {
            if (deck.length === 0) {
                return;
            }
            let back_img = new Image();
            back_img.src = "assets/cardback.png";
            back_img.onload = function () {
                ctx.drawImage(back_img,
                    .5 * canvas.width + 3 * card_w / 2 + 2 * cards_margin + 2,
                    .5 * canvas.height + cards_margin + 2,
                    card_w - 4,
                    card_h - 4
                );
            }
        }

        function update_active_card_player_1(card) {
            let image = new Image();
            image.src = card;
            image.onload = function () {
                ctx.drawImage(image, .5 * canvas.width - card_w / 2 + 2, .5 * canvas.height + cards_margin + 2, card_w - 4, card_h - 4);
            }
        }

        function update_active_card_player_2(card) {
            let image_2 = new Image();
            image_2.src = card;
            image_2.onload = function () {
                ctx.drawImage(image_2, (.5 * canvas.width - card_w / 2 + 2), (.5 * canvas.height - cards_margin - card_h + 2), card_w - 4, card_h - 4);
            }
        }

        function update_bench_player_1(bench) {
            for (let i = 0; i < bench.length; i++) {
                let image = new Image();
                image.src = bench[i];
                image.onload = function () {
                    ctx.drawImage(image,
                        .5 * canvas.width - (5 - 2 * i) * card_w / 2 - (2 - i) * cards_margin + 2,
                        .5 * canvas.height - 2 * cards_margin - 2 * card_h + 2,
                        card_w - 4,
                        card_h - 4
                    );
                }
            }
        }

        function update_bench_player_2(bench) {
            for (let i = 0; i < bench.length; i++) {
                let image = new Image();
                image.src = bench[i];
                image.onload = function () {
                    ctx.drawImage(image,
                        .5 * canvas.width - (5 - 2 * i) * card_w / 2 - (2 - i) * cards_margin + 2,
                        .5 * canvas.height + 2 * cards_margin + card_h + 2,
                        card_w - 4,
                        card_h - 4
                    );
                }
            }
        }

        // update deck
        update_deck_1(game_status.player_1.deck);
        update_deck_2(game_status.player_2.deck);

        // update active
        game_status.player_1.active = game_status.player_1.deck.pop();
        update_active_card_player_1(game_status.player_1.active);
        game_status.player_2.active = game_status.player_2.deck.pop();
        update_active_card_player_2(game_status.player_2.active);

        // update bench
        game_status.player_1.bench = game_status.player_1.deck.splice(0, 5)
        game_status.player_2.bench = game_status.player_2.deck.splice(0, 5)
        update_bench_player_1(game_status.player_1.bench);
        update_bench_player_2(game_status.player_2.bench);

        console.log(game_status);
    })();
</script>

</html>